<?php
require_once(__DIR__ . '/../inc/config.php');
require_once(__DIR__ . '/../inc/smart_resize_image.php');
require_once(__DIR__ . '/user_area_inc.php');

/*--------------------------------------------------
init vars
--------------------------------------------------*/
$errors = array();

// has errors
$has_errors = false;

// bot honey pot
// do later

// default assume place submitted successfully
$result_message = '';

/*--------------------------------------------------
Post vars
--------------------------------------------------*/
$latlng              = (!empty($_POST['latlng']             )) ? $_POST['latlng']              : '';
$plan_id             = (!empty($_POST['plan_id']            )) ? $_POST['plan_id']             : '';
$place_name          = (!empty($_POST['place_name']         )) ? $_POST['place_name']          : '';
$address             = (!empty($_POST['address']            )) ? $_POST['address']             : '';
$postal_code         = (!empty($_POST['postal_code']        )) ? $_POST['postal_code']         : '';
$cross_street        = (!empty($_POST['cross_street']       )) ? $_POST['cross_street']        : '';
$neighborhood        = (!empty($_POST['neighborhood']       )) ? $_POST['neighborhood']        : '';
$city_id             = (!empty($_POST['city_id']            )) ? $_POST['city_id']             : NULL;
$inside              = (!empty($_POST['inside']             )) ? $_POST['inside']              : '';
$area_code           = (!empty($_POST['area']               )) ? $_POST['area']                : NULL;
$phone               = (!empty($_POST['phone']              )) ? $_POST['phone']               : '';
$twitter             = (!empty($_POST['twitter']            )) ? $_POST['twitter']             : '';
$facebook            = (!empty($_POST['facebook']           )) ? $_POST['facebook']            : '';
$foursq_id           = (!empty($_POST['foursq_id']          )) ? $_POST['foursq_id']           : '';
$website             = (!empty($_POST['website']            )) ? $_POST['website']             : '';
$description         = (!empty($_POST['description']        )) ? $_POST['description']         : '';
$category_id         = (!empty($_POST['category_id']        )) ? $_POST['category_id']         : '';
$business_hours      = (!empty($_POST['business_hours']     )) ? $_POST['business_hours']      : array();
$business_hours_info = (!empty($_POST['business_hours_info'])) ? $_POST['business_hours_info'] : '';
$uploads             = (!empty($_POST['uploads']            )) ? $_POST['uploads']             : array();
$delete_temp_pics    = (!empty($_POST['delete_temp_pics']   )) ? $_POST['delete_temp_pics']    : array();

/*--------------------------------------------------
prepare vars
--------------------------------------------------*/
// trim
$latlng              = is_string($latlng)              ? trim($latlng)              : $latlng;
$plan_id             = is_string($plan_id)             ? trim($plan_id)             : $plan_id ;
$place_name          = is_string($place_name)          ? trim($place_name)          : $place_name;
$address             = is_string($address)             ? trim($address)             : $address;
$postal_code         = is_string($postal_code)         ? trim($postal_code)         : $postal_code;
$cross_street        = is_string($cross_street)        ? trim($cross_street)        : $cross_street;
$neighborhood        = is_string($neighborhood)        ? trim($neighborhood)        : $neighborhood;
$inside              = is_string($inside)              ? trim($inside)              : $inside;
$area_code           = is_string($area_code)           ? trim($area_code)           : $area_code;
$phone               = is_string($phone)               ? trim($phone)               : $phone;
$twitter             = is_string($twitter)             ? trim($twitter)             : $twitter;
$facebook            = is_string($facebook)            ? trim($facebook)            : $facebook;
$foursq_id           = is_string($foursq_id)           ? trim($foursq_id)           : $foursq_id;
$website             = is_string($website)             ? trim($website)             : $website;
$description         = is_string($description)         ? trim($description)         : $description;
$business_hours      = is_string($business_hours)      ? trim($business_hours)      : $business_hours;
$business_hours_info = is_string($business_hours_info) ? trim($business_hours_info) : $business_hours_info;
$uploads             = is_string($uploads)             ? trim($uploads)             : $uploads;
$delete_temp_pics    = is_string($delete_temp_pics)    ? trim($delete_temp_pics)    : $delete_temp_pics;

// check plan id selection
if(empty($plan_id) && !$is_admin) {
	trigger_error("Invalid plan selection", E_USER_ERROR);
}

// get plan details
/* plan types
free
free_feat
one_time
one_time_feat
monthly
monthly_feat
*/
$query = "SELECT plan_type, plan_name, plan_period, plan_price, plan_status FROM plans WHERE plan_id = :plan_id";
$stmt = $conn->prepare($query);
$stmt->bindValue(':plan_id', $plan_id);
$stmt->execute();
$row = $stmt->fetch(PDO::FETCH_ASSOC);
$plan_type   = (!empty($row['plan_type']))   ? $row['plan_type']   : '';
$plan_name   = (!empty($row['plan_name']))   ? $row['plan_name']   : '';
$plan_period = (!empty($row['plan_period'])) ? $row['plan_period'] : 0;
$plan_price  = (!empty($row['plan_price']))  ? $row['plan_price']  : 0;
$plan_status = (!empty($row['plan_status'])) ? $row['plan_status'] : '';

// if not a free plan
if($plan_type != 'free' && $plan_type != 'free_feat') {
	// if it's a monthly plan
	if($plan_type == 'monthly' || $plan_type == 'monthly_feat') {
		// init vars
		$cmd = "_xclick-subscriptions";
		$p3  = '';
		$t3  = '';
		$src = '';
		$srt = '';
		$a3 = $plan_price;

		if($plan_type == 'monthly' || $plan_type == 'monthly_feat') {
			$p3  = '1';
			$t3  = 'M';
			$src = '1';
			$srt = '52';
		}
	}

	// if it's a one time plan
	if($plan_type == 'one_time' || $plan_type == 'one_time_feat') {
		// init vars
		$cmd = "_xclick";
		$amount = $plan_price;
	}

	// bn (<Company>_<Service>_<Product>_<Country>)
	$bn = $paypal_bn . '_Subscribe_WPS_' . $default_country_code;
} // end if($plan_type != 'free' && $plan_type != 'free_feat')

// lat/lng
if(!empty($latlng)) {
	$latlng = str_replace('(', '', $latlng);
	$latlng = str_replace(')', '', $latlng);
	$latlng = explode(',', $latlng);
	$lat    = trim($latlng[0]);
	$lng    = trim($latlng[1]);

	settype($lat, 'float');
	settype($lng, 'float');
}

// clean phone
$area     = preg_replace("/[^0-9]/", "", $area_code);
$phone    = preg_replace("/[^0-9]/", "", $phone);

// normalize twitter url
$twitter  = twitter_url(trim($twitter));

// normalize facebook url
$facebook = facebook_url(trim($facebook));

// clean and normalize website url
$website  = site_url(trim($website));

// check valid foursquare id
if(!validate_username($foursq_id)) {
	$errors[] = 'Invalid Foursquare Id';
	$foursq_id = '';
}

// if city id is empty, try to guess
// use function to get city name using lat lng coords
$state_id = 0;
if(is_null($city_id)) {
	if(is_float($lat) && is_float($lng)) {
		$query = "SELECT * , (3959 * ACOS(COS(RADIANS($lat)) * COS(RADIANS(lat)) * COS(RADIANS(lng) - RADIANS($lng)) + SIN(RADIANS($lat)) * SIN( RADIANS(lat)))) AS distance FROM cities ORDER BY distance ASC LIMIT 1";
		$stmt = $conn->prepare($query);
		$stmt->execute();
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		$city_id  = $row['city_id'];
		$state_id = $row['state_id'];
	}
	else {
		die('wrong lat/lng value type');
	}
}

// if state_id empty
if(empty($state_id) && !empty($city_id)) {
	$query = "SELECT state_id FROM cities WHERE city_id = :city_id";
	$stmt = $conn->prepare($query);
	$stmt->bindValue(':city_id', $city_id);
	$stmt->execute();
	$row = $stmt->fetch(PDO::FETCH_ASSOC);
	$state_id = $row['state_id'];
}

// initial status
$status = "pending";
$paid   = 0;

// is this user the admin?
if($is_admin == 1) {
	$status = "approved";
	$paid = 1;
}

// if free plan types, set paid to 1
if($plan_type == 'free' || $plan_type == 'free_feat') {
	$paid = 1;
}

/*--------------------------------------------------
Submit routine
--------------------------------------------------*/
// check if this page is refreshed/reloaded
// if $_SESSION['submit_token'] and submitted $_POST['submit_token'] match
// it means that the page has not been reloaded,
// process insert, then unset $_SESSION['submit_token'],
// so that if user reloads this page, it doesn't match, so it's not inserted
$post_token = (!empty($_POST['submit_token'])) ? $_POST['submit_token'] : 'aaa';
$session_token = (isset($_SESSION['submit_token'])) ? $_SESSION['submit_token'] : '';
if($post_token == $session_token) {
	try {
		$conn->beginTransaction();

		// neighborhood logic
		if(!empty($neighborhood)) {
			$neighborhood_slug = to_slug($neighborhood);

			$query = "SELECT * FROM neighborhoods
						WHERE neighborhood_slug = :neighborhood_slug AND city_id = :city_id LIMIT 1";
			$stmt = $conn->prepare($query);
			$stmt->bindValue(':neighborhood_slug', $neighborhood_slug);
			$stmt->bindValue(':city_id', $city_id);
			$stmt->execute();
			$row = $stmt->fetch(PDO::FETCH_ASSOC);

			// this neighborhood in this city already exists
			if($neighborhood_slug == $row['neighborhood_slug']) {
					$neighborhood_id = $row['neighborhood_id'];
			}
			else {
				$query = "INSERT INTO neighborhoods(neighborhood_slug, neighborhood_name, city_id)
							VALUES(:neighborhood_slug, :neighborhood_name, :city_id)";
				$stmt = $conn->prepare($query);
				$stmt->bindValue(':neighborhood_slug', $neighborhood_slug);
				$stmt->bindValue(':neighborhood_name', $neighborhood);
				$stmt->bindValue(':city_id', $city_id);
				$stmt->execute();

				$neighborhood_id = $conn->lastInsertId();
			}
		}

		$neighborhood_id = (isset($neighborhood_id) && !empty($neighborhood_id)) ? $neighborhood_id : NULL;

		// insert into places table
		$query = "INSERT INTO places(
			userid,
			lat,
			lng,
			place_name,
			address,
			postal_code,
			cross_street,
			neighborhood,
			city_id,
			state_id,
			inside,
			area_code,
			phone,
			twitter,
			facebook,
			foursq_id,
			website,
			description,
			business_hours_info,
			plan,
			valid_until,
			status,
			paid
		)
		VALUES(
			:userid,
			:lat,
			:lng,
			:place_name,
			:address,
			:postal_code,
			:cross_street,
			:neighborhood,
			:city_id,
			:state_id,
			:inside,
			:area_code,
			:phone,
			:twitter,
			:facebook,
			:foursq_id,
			:website,
			:description,
			:business_hours_info,
			:plan,
			DATE_ADD(CURRENT_TIMESTAMP, INTERVAL :valid_until DAY),
			:status,
			:paid
		)";

		// set valid until value which is just the number of days of the period
		$valid_until = ($plan_period == 0) ? 9999 : $plan_period;

		$stmt = $conn->prepare($query);
		$stmt->bindValue(':userid'              , $userid);
		$stmt->bindValue(':lat'                 , $lat);
		$stmt->bindValue(':lng'                 , $lng);
		$stmt->bindValue(':place_name'          , $place_name);
		$stmt->bindValue(':address'             , $address);
		$stmt->bindValue(':postal_code'         , $postal_code);
		$stmt->bindValue(':cross_street'        , $cross_street);
		$stmt->bindValue(':neighborhood'        , $neighborhood_id);
		$stmt->bindValue(':city_id'             , $city_id);
		$stmt->bindValue(':state_id'            , $state_id);
		$stmt->bindValue(':inside'              , $inside);
		$stmt->bindValue(':area_code'           , $area_code);
		$stmt->bindValue(':phone'               , $phone);
		$stmt->bindValue(':twitter'             , $twitter);
		$stmt->bindValue(':facebook'            , $facebook);
		$stmt->bindValue(':foursq_id'           , $foursq_id);
		$stmt->bindValue(':website'             , $website);
		$stmt->bindValue(':description'         , $description);
		$stmt->bindValue(':business_hours_info' , $business_hours_info);
		$stmt->bindValue(':plan'                , $plan_id);
		$stmt->bindValue(':valid_until'         , $valid_until);
		$stmt->bindValue(':status'              , $status);
		$stmt->bindValue(':paid'                , $paid);
		$stmt->execute();

		$place_id = $conn->lastInsertId();

		// rel_place_cat
		if(!empty($category_id)) {
			if(is_numeric($category_id)) {
				$query = "INSERT INTO rel_place_cat(place_id, cat_id, city_id)
					VALUES(:place_id, :cat_id, :city_id)";
				$stmt = $conn->prepare($query);
				$stmt->bindValue(':place_id', $place_id);
				$stmt->bindValue(':cat_id', $category_id);
				$stmt->bindValue(':city_id', $city_id);
				$stmt->execute();
			}
		}

		// business hours
		$allowed_hours = array("0000", "0030", "0100", "0130", "0200", "0230", "0300", "0330", "0400", "0430", "0500", "0530", "0600", "0630", "0700", "0730", "0800", "0830", "0900", "0930", "1000", "1030", "1100", "1130", "1200", "1230", "1300", "1330", "1400", "1430", "1500", "1530", "1600", "1630", "1700", "1730", "1800", "1830", "1900", "1930", "2000", "2030", "2100", "2130", "2200", "2230", "2300", "2330");
		$allowed_days = array("0", "1", "2", "3", "4", "5", "6");

		// now add submitted business hours
		$business_hours_count = 1; // counter to limit number of categories submitted

		foreach($business_hours as $k => $v) {
			$each_day = explode(',', $v);
			$day = $each_day[0];
			$open = $each_day[1];
			$close = $each_day[2];

			if(in_array($day, $allowed_days) && in_array($open, $allowed_hours) && in_array($close, $allowed_hours)) {
				$stmt = $conn->prepare('INSERT INTO business_hours(place_id, day, open, close)	VALUES(:place_id, :day, :open, :close)');
				$stmt->bindValue(':place_id', $place_id);
				$stmt->bindValue(':day', $day);
				$stmt->bindValue(':open', $open);
				$stmt->bindValue(':close', $close);
				$stmt->execute();
				$business_hours_count++;
			}
		}

		// photos

		// delete pics from temp folder that were deleted by user while posting
		if(!empty($delete_temp_pics)) {
			foreach($delete_temp_pics as $v) {
				$temp_pic_path = __DIR__ . '/../place_pic_tmp/' . $v;
				if(is_file($temp_pic_path)) {
					unlink($temp_pic_path);
				}
			}
		}

		// uploaded images
		if(!empty($uploads)) {
			// define dirs
			$query = "SELECT photo_id FROM photos ORDER BY photo_id DESC LIMIT 1";
			$stmt = $conn->prepare($query);
			$stmt->execute();
			$row = $stmt->fetch(PDO::FETCH_ASSOC);
			$last_photo_id = $row['photo_id'];
			$dir_num = floor($last_photo_id / 1000) + 1;

			$dir_full  = __DIR__ . '/../place_pic_full/' . $dir_num;
			$dir_thumb = __DIR__ . '/../place_pic_thumb/' . $dir_num;

			if (!is_dir($dir_full)) {
				mkdir($dir_full, 0777, true);
			}

			if (!is_dir($dir_thumb)) {
				mkdir($dir_thumb, 0777, true);
			}

			// tmp folder
			$tmp_folder = __DIR__ . '/../place_pic_tmp';

			foreach($uploads as $v) {
				// only insert into db if the move from temp to final destination folder is successful,
				// otherwise user could send custom uploads[] value and replace original(thus deleting) previous pics
				// from other ads
				$tmp_file = $tmp_folder . '/' . $v;

				if(copy($tmp_file, $dir_full . '/' . $v)) {
					// insert into photos table
					$stmt = $conn->prepare('
					INSERT INTO photos(place_id, dir, filename)
					VALUES(:place_id, :dir, :filename)');

					$stmt->bindValue(':place_id', $place_id);
					$stmt->bindValue(':dir'     , $dir_num);
					$stmt->bindValue(':filename', $v);
					$stmt->execute();
				}

				smart_resize_image($tmp_file, null, 250, 250, false, $dir_thumb . '/' . $v, true, false, 85);

				// delete pic from tmp_photos table
				$query = "DELETE FROM tmp_photos WHERE filename = :filename";
				$stmt = $conn->prepare($query);
				$stmt->bindValue(':filename', $v);
				$stmt->execute();
			}
		} // end if(!empty($uploads))

		$conn->commit();
		$has_errors = false;
		$txt_main_title = $txt_main_title_success;
		$result_message = $txt_checkout_msg;
	} // end try block ()
	catch(PDOException $e) {
		$conn->rollBack();
		$has_errors = true;
		$txt_main_title = $txt_main_title_error;
		$result_message =  $e->getMessage();
	}

	// empty session submit token
	unset($_SESSION['submit_token']);
} // end if($post_token == $session_token)
else { // else probably user reloaded page
	$has_errors = false; // false so the paypal button is shown
	$txt_main_title = $txt_main_title_success;
	$result_message = $txt_checkout_msg;
}

// thanks messages
$txt_thanks = (!$is_admin) ? $txt_thanks_msg : $txt_thanks_admin;

// template file
require_once(__DIR__ . '/../templates/user_templates/tpl_process-add-place.php');